--- ../../tmp/asterisk-1.4.5/cdr/cdr_pgsql.c	2007-06-14 15:50:40.000000000 -0600
+++ cdr_pgsql.c	2007-06-20 13:21:16.000000000 -0600
@@ -88,6 +88,7 @@
 			pgerror = PQerrorMessage(conn);
 			ast_log(LOG_ERROR, "cdr_pgsql: Unable to connect to database server %s.  Calls will not be logged!\n", pghostname);
                         ast_log(LOG_ERROR, "cdr_pgsql: Reason: %s\n", pgerror);
+			PQfinish(conn);
 		}
 	}
 
@@ -148,6 +149,7 @@
 				ast_log(LOG_ERROR, "cdr_pgsql: Unable to reconnect to database server %s. Calls will not be logged!\n", pghostname);
 				ast_log(LOG_ERROR, "cdr_pgsql: Reason: %s\n", pgerror);
 				connected = 0;
+				PQfinish(conn);
 				ast_mutex_unlock(&pgsql_lock);
 				return -1;
 			}
@@ -162,6 +164,7 @@
 			if (PQstatus(conn) == CONNECTION_OK) {
 				ast_log(LOG_ERROR, "cdr_pgsql: Connection reestablished.\n");
 				connected = 1;
+				PQclear(result);
 				result = PQexec(conn, sqlcmd);
 				if (PQresultStatus(result) != PGRES_COMMAND_OK) {
 					pgerror = PQresultErrorMessage(result);
